class LSTM(Module):
  __parameters__ = ["weight_ih_l0", "weight_hh_l0", "bias_ih_l0", "bias_hh_l0", ]
  __buffers__ = []
  weight_ih_l0 : Tensor
  weight_hh_l0 : Tensor
  bias_ih_l0 : Tensor
  bias_hh_l0 : Tensor
  training : bool
  _is_full_backward_hook : NoneType
  _flat_weights_names : List[str]
  _all_weights : List[List[str]]
  _flat_weights : List[Tensor]
  dropout : Final[float] = 0.
  mode : Final[str] = "LSTM"
  batch_first : Final[bool] = False
  num_layers : Final[int] = 1
  proj_size : Final[int] = 0
  input_size : Final[int] = 47
  bias : Final[bool] = True
  hidden_size : Final[int] = 64
  bidirectional : Final[bool] = False
  def forward__0(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[Tensor, Tuple[Tensor, Tensor]]:
    _0 = "LSTM: Expected input to be 2D or 3D, got {}D instead"
    _1 = "For batched 3-D input, hx and cx should also be 3-D but got ({}-D, {}-D) tensors"
    _2 = "For unbatched 2-D input, hx and cx should also be 2-D but got ({}-D, {}-D) tensors"
    _3 = (self)._update_flat_weights()
    _4 = torch.dim(input)
    _5 = torch.__not__(torch.__contains__([2, 3], _4))
    if _5:
      _6 = torch.format(_0, torch.dim(input))
      ops.prim.RaiseException(_6, "builtins.ValueError")
    else:
      pass
    is_batched = torch.eq(torch.dim(input), 3)
    if torch.__not__(is_batched):
      input0 = torch.unsqueeze(input, 1)
    else:
      input0 = input
    max_batch_size = torch.size(input0, 1)
    if torch.__is__(hx, None):
      _7 = ops.prim.dtype(input0)
      _8 = ops.prim.device(input0)
      h_zeros = torch.zeros([1, max_batch_size, 64], dtype=_7, layout=None, device=_8)
      _9 = ops.prim.dtype(input0)
      _10 = ops.prim.device(input0)
      c_zeros = torch.zeros([1, max_batch_size, 64], dtype=_9, layout=None, device=_10)
      hx1 = (h_zeros, c_zeros)
      _11 = (self).check_forward_args(input0, hx1, None, )
      hx0 = hx1
    else:
      hx2 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      if is_batched:
        _12 = torch.ne(torch.dim((hx2)[0]), 3)
        if _12:
          _13 = True
        else:
          _14 = torch.ne(torch.dim((hx2)[1]), 3)
          _13 = _14
        if _13:
          msg = torch.format(_1, torch.dim((hx2)[0]), torch.dim((hx2)[1]))
          ops.prim.RaiseException(msg, "builtins.RuntimeError")
        else:
          pass
        hx3 = hx2
      else:
        _15 = torch.ne(torch.dim((hx2)[0]), 2)
        if _15:
          _16 = True
        else:
          _17 = torch.ne(torch.dim((hx2)[1]), 2)
          _16 = _17
        if _16:
          msg0 = torch.format(_2, torch.dim((hx2)[0]), torch.dim((hx2)[1]))
          ops.prim.RaiseException(msg0, "builtins.RuntimeError")
        else:
          pass
        hx4 = (torch.unsqueeze((hx2)[0], 1), torch.unsqueeze((hx2)[1], 1))
        hx3 = hx4
      _18 = (self).check_forward_args(input0, hx3, None, )
      hx5 = (self).permute_hidden(hx3, None, )
      hx0 = hx5
    _flat_weights = self._flat_weights
    training = self.training
    _19, _20, = hx0
    _21, _22, _23 = torch.lstm(input0, [_19, _20], _flat_weights, True, 1, 0., training, False, False)
    hidden = (_22, _23)
    if torch.__not__(is_batched):
      output0 = torch.squeeze(_21, 1)
      hidden1 = (torch.squeeze(_22, 1), torch.squeeze(_23, 1))
      hidden0, output = hidden1, output0
    else:
      hidden0, output = hidden, _21
    _24 = (self).permute_hidden(hidden0, None, )
    return (output, _24)
  def forward__1(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: __torch__.torch.nn.utils.rnn.PackedSequence,
    hx: Optional[Tuple[Tensor, Tensor]]=None) -> Tuple[__torch__.torch.nn.utils.rnn.PackedSequence, Tuple[Tensor, Tensor]]:
    _25 = (self)._update_flat_weights()
    input1, batch_sizes, sorted_indices, unsorted_indices, = input
    max_batch_size = torch.select(batch_sizes, 0, 0)
    if torch.__is__(hx, None):
      _26 = ops.prim.dtype(input1)
      _27 = ops.prim.device(input1)
      _28 = [1, annotate(int, max_batch_size), 64]
      h_zeros = torch.zeros(_28, dtype=_26, layout=None, device=_27)
      _29 = ops.prim.dtype(input1)
      _30 = ops.prim.device(input1)
      _31 = [1, annotate(int, max_batch_size), 64]
      c_zeros = torch.zeros(_31, dtype=_29, layout=None, device=_30)
      hx6 = (h_zeros, c_zeros)
    else:
      hx7 = unchecked_cast(Tuple[Tensor, Tensor], hx)
      hx8 = (self).permute_hidden(hx7, sorted_indices, )
      hx6 = hx8
    _flat_weights = self._flat_weights
    training = self.training
    _32, _33, = hx6
    _34, _35, _36 = torch.lstm(input1, batch_sizes, [_32, _33], _flat_weights, True, 1, 0., training, False)
    hidden = (_35, _36)
    output_packed = __torch__.torch.nn.utils.rnn.PackedSequence(_34, batch_sizes, sorted_indices, unsorted_indices)
    _37 = (self).permute_hidden(hidden, unsorted_indices, )
    return (output_packed, _37)
  def _update_flat_weights(self: __torch__.torch.nn.modules.rnn.LSTM) -> NoneType:
    return None
  def check_forward_args(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    hidden: Tuple[Tensor, Tensor],
    batch_sizes: Optional[Tensor]) -> NoneType:
    _38 = "Expected hidden[0] size {}, got {}"
    _39 = "Expected hidden[1] size {}, got {}"
    _40 = (self).check_input(input, batch_sizes, )
    _41 = (hidden)[0]
    _42 = (self).get_expected_hidden_size(input, batch_sizes, )
    _43 = (self).check_hidden_size(_41, _42, _38, )
    _44 = (hidden)[1]
    _45 = (self).get_expected_cell_size(input, batch_sizes, )
    _46 = (self).check_hidden_size(_44, _45, _39, )
    return None
  def check_input(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> NoneType:
    _47 = "input must have {} dimensions, got {}"
    _48 = "input.size(-1) must be equal to input_size. Expected {}, got {}"
    if torch.__isnot__(batch_sizes, None):
      expected_input_dim = 2
    else:
      expected_input_dim = 3
    _49 = torch.ne(torch.dim(input), expected_input_dim)
    if _49:
      _50 = torch.format(_47, expected_input_dim, torch.dim(input))
      ops.prim.RaiseException(_50, "builtins.RuntimeError")
    else:
      pass
    if torch.ne(47, torch.size(input, -1)):
      _51 = torch.format(_48, 47, torch.size(input, -1))
      ops.prim.RaiseException(_51, "builtins.RuntimeError")
    else:
      pass
    return None
  def check_hidden_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    hx: Tensor,
    expected_hidden_size: Tuple[int, int, int],
    msg: str="Expected hidden size {}, got {}") -> NoneType:
    _52 = torch.size(hx)
    _53, _54, _55, = expected_hidden_size
    if torch.ne(_52, [_53, _54, _55]):
      _56 = torch.format(msg, expected_hidden_size, torch.list(torch.size(hx)))
      ops.prim.RaiseException(_56, "builtins.RuntimeError")
    else:
      pass
    return None
  def get_expected_hidden_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes0 = unchecked_cast(Tensor, batch_sizes)
      mini_batch0 = int(torch.select(batch_sizes0, 0, 0))
      mini_batch = mini_batch0
    else:
      mini_batch = torch.size(input, 1)
    return (1, mini_batch, 64)
  def get_expected_cell_size(self: __torch__.torch.nn.modules.rnn.LSTM,
    input: Tensor,
    batch_sizes: Optional[Tensor]) -> Tuple[int, int, int]:
    if torch.__isnot__(batch_sizes, None):
      batch_sizes1 = unchecked_cast(Tensor, batch_sizes)
      mini_batch1 = int(torch.select(batch_sizes1, 0, 0))
      mini_batch = mini_batch1
    else:
      mini_batch = torch.size(input, 1)
    return (1, mini_batch, 64)
  def permute_hidden(self: __torch__.torch.nn.modules.rnn.LSTM,
    hx: Tuple[Tensor, Tensor],
    permutation: Optional[Tensor]) -> Tuple[Tensor, Tensor]:
    _57 = __torch__.torch.nn.modules.rnn._apply_permutation
    if torch.__is__(permutation, None):
      _58 = hx
    else:
      permutation0 = unchecked_cast(Tensor, permutation)
      _59 = (_57((hx)[0], permutation0, 1, ), _57((hx)[1], permutation0, 1, ))
      _58 = _59
    return _58
def _apply_permutation(tensor: Tensor,
    permutation: Tensor,
    dim: int=1) -> Tensor:
  _60 = torch.index_select(tensor, dim, permutation)
  return _60
